Ti.include("import.js");
var y = {foo:'bar'};

var win = Ti.UI.createWindow({
	backgroundColor:'white'
});

var f = function() {
	var foo = "a";
	Ti.API.info("Inside anonymous function: "+foo);
	Ti.API.info("Global val: "+x);
	x+=1;
};

function recurse(e) {
	var y = (e % 4 > 0) ? -1 : 1;
	if (e==100) {
		return;
	}
	Ti.API.info("Recursive function frame:"+e);
	recurse(e+1);
}

var fr = function(x) {
	if (x==100) {
		return;
	}
	Ti.API.info("Anonymous recursive function frame:"+x);
	fr(x+1);
}

var b1 = Ti.UI.createButton({
	title:'Anonymous f/g',
	width:140,
	height:40,
	top:20
});
b1.addEventListener('click', function(e) {
	var dumb = 5;
	f();
	var g = f;
	g();
});
win.add(b1);

var b2 = Ti.UI.createButton({
	title:"Recurse",
	width:140,
	height:40,
	top:80
});
b2.addEventListener('click', function(e) {
	recurse(90);
	fr(90);
});
win.add(b2);

var b3 = Ti.UI.createButton({
	title:'Open window',
	width:140,
	height:40,
	top:140
});
b3.addEventListener('click', function(e) {
	var newWin = Ti.UI.createWindow({
		url:'nextwin.js'
	});
	newWin.open();
});
win.add(b3);

function cfb() {
	var b=2;
	Ti.API.info('b: '+b);
}
function cfa(){
	var a=1;
	Ti.API.info('a: '+a);
	cfb();
}

cfa();

var b4=Ti.UI.createButton({
	title:"Callframe nesting",
	width:140,
	height:40,
	top:200
});
b4.addEventListener('click',function() {
	cfa();
});
win.add(b4);

var b5=Ti.UI.createButton({
	title:"Shadowing",
	width:140,
	height:40,
	top:260
});
b5.addEventListener('click',function() {
	var x = "foo";
	Ti.API.info("Shadow x: "+x);
});
win.add(b5);

var b6=Ti.UI.createButton({
	title:"Imported call",
	width:140,
	height:40,
	top:320
});
b6.addEventListener('click',function(){
	imported(3);
});
win.add(b6);

var b7 = Ti.UI.createButton({
	title:"App event/timer",
	width:140,
	height:40,
	top:380
});
b7.addEventListener('click', function() {
	Titanium.App.fireEvent('appEvent',{x:['y','z']});
});
win.add(b7);

Titanium.App.addEventListener('appEvent', function(e)
{
	var t = "here";
	Ti.API.info("Hit app-level event: "+e);
	setTimeout(function()
	{
		var v = "there";
		Ti.API.info("Event listener value in timeout: "+e)
		Ti.API.info("Hit timeout: "+t+" "+v);
	},1000);
});

win.open();
